<?php
/*
Plugin Name: AskApache Crazy Cache
Plugin URI: http://www.askapache.com/wordpress/wp-cache-all-hack.html
Description: Caches Entire Site if using WP-Cache.  <a href="options-general.php?page=aa-crazy-cache.php">Options configuration panel</a>
Version: 1.0
Author: AskApache
Author URI: http://www.askapache.com
*/

/*
== Installation ==

1. Upload aa-crazy-cache.zip to the /wp-content/plugins/ directory
2. Unzip into its own folder /wp-content/plugins/aa-crazy-cache/aa-crazy-cache.php
3. Activate the plugin through the 'Plugins' menu in WordPress by clicking "AskApache Crazy Cache"
4. Go to your Options Panel and open the "AA Crazy Cache" submenu. /wp-admin/options-general.php?page=aa-crazy-cache.php
*/


/*
/--------------------------------------------------------------------\
|                                                                    |
| License: GPL                                                       |
|                                                                    |
| AskApache Crazy Cache Plugin - Caches Entire Site if using WP-Cache|
| Copyright (C) 2008, AskApache, www.askapache.com                   |
| All rights reserved.                                               |
|                                                                    |
| This program is free software; you can redistribute it and/or      |
| modify it under the terms of the GNU General Public License        |
| as published by the Free Software Foundation; either version 2     |
| of the License, or (at your option) any later version.             |
|                                                                    |
| This program is distributed in the hope that it will be useful,    |
| but WITHOUT ANY WARRANTY; without even the implied warranty of     |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      |
| GNU General Public License for more details.                       |
|                                                                    |
| You should have received a copy of the GNU General Public License  |
| along with this program; if not, write to the                      |
| Free Software Foundation, Inc.                                     |
| 51 Franklin Street, Fifth Floor                                    |
| Boston, MA  02110-1301, USA                                        |   
|                                                                    |
\--------------------------------------------------------------------/
*/



// aa_cache_all_options_setup
//---------------------------
function aa_cache_all_options_setup() {
	global $aa_CA;
    add_options_page($aa_CA['Name'], 'AA Crazy Cache', 8, basename(__FILE__), 'aa_cache_all_page');
}//=====================================================================================


//aa_cache_admin_header
function aa_cache_admin_header(){
	global $wpdb,$cache_path, $file_prefix, $cache_max_time, $aa_CA, $aa_crazy_wpcache_enabled, $aa_cc_valid_nonce;
	
	$aa_CA=get_option('askapache_crazy_cache');
	
	if (get_option('active_plugins'))$current_plugins = get_option('active_plugins');
	$plugins = get_plugins();
	foreach($plugins as $plugin_file => $plugin_data) {
		if (!empty($current_plugins) && in_array($plugin_file, $current_plugins) && (false!==($t=strpos($plugin_file, 'wp-cache'))))$aa_crazy_wpcache_enabled=true;
	}
	if($aa_crazy_wpcache_enabled){
		$wp_cache_config_file = ABSPATH . 'wp-content/wp-cache-config.php';
		$wp_cache_config_file_sample = ABSPATH . 'wp-content/plugins/wp-cache/wp-cache-config-sample.php';
		$wp_cache_link = ABSPATH . 'wp-content/advanced-cache.php';
		$wp_cache_file = ABSPATH . 'wp-content/plugins/wp-cache/wp-cache-phase1.php';
		if( !@include($wp_cache_config_file) ) @include($wp_cache_config_file_sample);
		@require(ABSPATH . 'wp-content/plugins/wp-cache/wp-cache-base.php');
	}
}//=====================================================================================




// aa_cache_all_page
//---------------------------
function aa_cache_all_page() {
	global $wpdb,$cache_path, $file_prefix, $cache_max_time, $aa_CA, $aa_crazy_wpcache_enabled, $aa_cc_valid_nonce;
	
	if (! user_can_access_admin_page()) wp_die( __('You do not have sufficient permissions to access this page.') );
	if (function_exists('current_user_can')&&!current_user_can(8)||!current_user_can('upload_files'))wp_die(__("You are not allowed to be here"));


    echo '<p style="text-align:center;">[  <a href="http://www.askapache.com/seo/404-google-wordpress-plugin.html">Google 404 SEO Plugin</a>'.
		 ' - Home: '.$aa_CA['Title'].' - Version: <strong>'.$aa_CA['Version'].'</strong> - Author: '.$aa_CA['Author'].' ]</p><hr style="visibility:hidden;">';
	echo '<div class="wrap"><h2>'.$aa_CA['Name'].'</h2> <hr style="visibility:hidden;">';
	
	if(!function_exists('curl_init') || !function_exists('gzuncompress')) echo '<p>OOPS!  Your server does not have curl and/or gzuncompress, sorry but you cannot use this plugin until I upgrade it.  Sorry.</p>';
	else {
	
	echo '<form name="wp_aa_cacheall" action="'. $_SERVER["REQUEST_URI"] . '" method="post">';
    echo '<fieldset class="options"><legend>Cache Entire Site</legend><input type="hidden" name="wp_aacacheall" />';
	
	if(!$aa_crazy_wpcache_enabled)echo "<p><strong>wp-cache is disabled!  Please enable it to use this plugin.</strong></p>";
	else echo "<p><strong>wp-cache is enabled</strong></p>";
	echo '<p><strong>Please note that caching your entire site takes about 7 seconds for every 15 posts</strong>.</p>';
	echo '<p>This AskApache Crazy Cache version only caches single posts for now...</p>';
	echo '<p>Many more options will be available in the future, I love it and hopefully the WordPress masses will too.</p>';
	
	echo '<div class="submit"><input type="submit" id="aacacheall" name="aacacheall" value="Cache Entire Site" />';
	if($aa_crazy_wpcache_enabled){
		echo '<input type="submit" id="aacachelist" name="aacachelist" value="List Cached Files" />';
		echo '<input type="submit" id="aacachedelete" name="aacachedelete" value="Delete Cached Files" />';
	}
	
	echo '</div>';
    wp_nonce_field('aa-crazy-cache-update_modify');
    echo "</fieldset></form></div>\n";

	echo '<div class="wrap">';
	if($_SERVER['REQUEST_METHOD']==='POST'){
        $aa_cc_valid_nonce = wp_verify_nonce($_REQUEST['_wpnonce'], 'aa-crazy-cache-update_modify');
		if(!$aa_cc_valid_nonce)die(__('Cheatin&#8217; uh?'));
		if(isset($_POST['aacacheall']))	aa_background_crazy_cache(); 
		if(isset($_POST['aacachedelete'])) aa_cache_delete();
		if(isset($_POST['aacachelist'])) aa_cache_list();
	}
	echo '</div>';
	
	}
}//=====================================================================================




	






function aa_cache_delete(){
	global $wpdb,$cache_path, $file_prefix, $cache_max_time, $aa_CA, $aa_crazy_wpcache_enabled, $aa_cc_valid_nonce;
	
	if(!$aa_cc_valid_nonce)die(__('Cheatin&#8217; uh?'));
	
	$files=glob("$cache_path$file_prefix*");
	$f=sizeof($files);
	if(wp_cache_phase2_clean_cache($file_prefix))echo "<p>Deleted: $f files from: $cache_path</p>";
	//else echo "<p>Error Deleting: $f files from: $cache_path</p>";
}




function aa_cache_list($list_files=true){
	global $wpdb,$cache_path, $file_prefix, $cache_max_time, $aa_CA, $aa_crazy_wpcache_enabled, $aa_cc_valid_nonce;
	
	if(!$aa_cc_valid_nonce)die(__('Cheatin&#8217; uh?'));

	$list_mess = "Update list";
	$list_files=true;
	$count = 0;
	$expired = 0;
	$now = time();
	ob_start();
	if ( ($handle = opendir( $cache_path )) ) { 
		if ($list_files) echo "<table cellspacing=\"0\" cellpadding=\"5\">";
		while ( false !== ($file = readdir($handle))) {
			if ( preg_match("/^$file_prefix.*\.meta/", $file) ) {
				$this_expired = false;
				$content_file = preg_replace("/meta$/", "html", $file);
				$mtime = filemtime($cache_path.$file);
				if ( ! ($fsize = @filesize($cache_path.$content_file)) ) 
					continue; // .meta does not exists
				$fsize = intval($fsize/1024);
				$age = $now - $mtime;
				if ( $age > $cache_max_time) {
					$expired++;
					$this_expired = true;
				}
				$count++;
				if ($list_files) {
					$meta = new CacheMeta;
					$meta = unserialize(file_get_contents($cache_path . $file));
					echo $flip ? '<tr style="background: #EAEAEA;">' : '<tr>';
					$flip = !$flip;
					echo '<td><a href="http://' . $meta->uri . '" target="_blank">';
					echo $meta->uri . "</a></td>";
					if ($this_expired) echo "<td><span style='color:red'>$age secs</span></td>";
					else echo "<td>$age secs</td>";
					echo "<td>$fsize KB</td>";
					wp_nonce_field('wp-cache');
					echo "</td></tr>\n";
				}
			}
		}
		closedir($handle);
		if ($list_files) echo "</table>";
	}
	$cacheft=ob_get_clean();
	
	echo "<p><strong>$count cached pages</strong></p>";
	echo "<p><strong>$expired expired pages</strong></p>";
	echo $cacheft;
}



function aa_background_crazy_cache(){

	// encoded this backend file to make it easy for people, 
	// didn't want people to have to install a 2nd file! 
	// gosh no that is asking too much! :)
	
	$e=
	'eJytV21v2zgS/pwA+Q8Tn1DJjSzb7eaSjVdpXddpg8sbbOfugFxOoCVaIiJRWkqKnXbz33dISo6a'.
	'l26Au7ZIRXLmmZmHM8PJbx+yKNvaZAtrm+U5LSzD+zKeXZlknmekiMzrdjtg1GoPtja1VEAXjNPA'.
	'MoefphfD2Vez3f6+tbnxUe8/bNtzktO//+IF1E8D+gTWMV0XVQdSlXE/LgPqpdynVqXvmMus46d8'.
	'wUIHPTSVpLT/ce3A50/e5XQ8QZQXAaqDvIvfwXwNdC+DMZaZ5xM/op424y1YTMGFSh8cqFwoKC8k'.
	'gBJu+jR4AcTLSZL9BCuLy5DxfI35GLyj9Z/aiBm/eRGVBLcE4w801FPln4b3sktZhPfYr+HwBmC7'.
	'vjDr2ejb0IafS1T8yJv4KOjvJRPrW3u1WzK71veJYRLi+b53S2IWeFzmgYuWb6lgizu9rjPQW2Zq'.
	'bV7bYBLS8QX5drcG9W8oDxQmWwCG+hQXVD2Y01SIO5inZQF+RGwY5jfDTIJATu5yuEtLIIICTwsg'.
	'cZwuaQBFCnMKERXUURZQ2L/xSJAw7gm6wH1h/cyjrU1BQ5YXVHh5VBZBuuTeouR+wVJuST+lXsV2'.
	'QGNaKIZZyFNBvTJHNTJPRWEVosQT6HZBlBxyX7CsAMZB2gpFWvJgaxM7gVewRKZcwgqr90R+gaBI'.
	'r/QKTT+oov04zqt+UXsHz3pn6caB/CVpYHne0fHJ2PPs3t7enu4LUHKZ8eujden+gKsQQ/S3FNKw'.
	'xAzjdE5iwOQL5rahJWTbscFQ+Zch3WyFK32UkJUKFjcQcDTU//947Soe1YCenqmM8DzLHEWUFIy/'.
	'+dv+u/7eAMrog25xqGlkrhG62mAgPXWJEOROEbVh+Ehd4Rp0lWEtBG5PbcZ4115C8xyrtnWZBaSg'.
	'IPdaD6cymtyVF6r2eLpEWRmKxlUeYxpbRkR4oMo/zTCdmLCgQQu0Zc1+BxTfWEayTViwIHFOYdt1'.
	'UbnqHIKSQKpWYG3UkmRvaBvIaYhMFn5ktbr/bfLsvP2Pk9CCdFsV/8qa0twwiojlXhU32lBmB0ZV'.
	'/3XPUtiCZjHBOm51JZgh0VpRkcRr1IGRyNAlCi7Vt9WI0qmktGFd3jK4nH2TOh8Vl/j9o07TE0WT'.
	'3GAcCZcFoeKCIKW5qnS6wkvJq8hqYMYLzJXKULffe/cLekpCeaQurAPa76Zj6vzwcX4ia3WK7OwM'.
	'nnCn0uC+sq4yCqUeQBsZI4GU5y5wuoSRtHKK60G9W3JsFwwzHOlQNynrq6IibxKE/VrTijE95PbV'.
	'tWtGRZEddLumozA7h6VglXPqp/rhx2lOmykl3VUVvoHkok3IUk2oQURYl4zJy2ROhToywT0Es9M3'.
	'bVOuvbwgRVntZuUcQ47qo+Iuo6Z7qBZ6nDCSOwWCAcv41LelLKlj2eIwJGstRnIw5Ff7u5FhiEqH'.
	'ioSoJqVOOofHn9sDHQGqW8YKa9lY/SavPl2gDNK02tlRTUo2E8gLEVOOB1fG6rp9WC89nGv+OZ5c'.
	'mV9nswvv6/l0hoMYvHkD2/hWaBa0it1gHbNTV5URonf6fFBzfa/bgaBFKTgYYd1KH7fTp538/9dQ'.
	'1QuwzLQM5WQe0+CFXrvxvzXbr+Ph5/FkWiWM5KA19H2aFQdQ0FXRXSWxTbIsZj6RgT9dy8ayI3eV'.
	'uFwNfnd7zq96jY2IcbWxb7MEa7Wb8dB+232r9nZbdsNi54TwsESZA6C8U+Y25c9JjTmOyYyHBxB+'.
	'Y5mNQ26M/f5HmVFEBD7MB3A8Pe/s7+/+2unbZbHo7CvAPVub36uURinnVN3rAYxkoVX7F4KECTlo'.
	'4ULTpSnDDPJkh3CfeVMHtcAcJzgtJIn1/KiUmV+r2v3d+tlZ105TSxWQytQ6/41FJhtXksksstp1'.
	'/iYR7vpSNSnjgnmM4wxSde4KGRS0rkkmy10uH54VP7oy2LWrMJS2OkYEwD8ooA6QyxRHGauStmF0'.
	'OTk5v5h5sup0CmF6Vrn0amX5O8nwy/hshvPlafqNxTHp7jo9sP7FOM5s+QAuB1B9w9kMdp3+QKbG'.
	'5XQA4vag7+w7faf/vg1fcDxMu+96vf3e+34fjrDNL9JV953Tw7/99+arPZqMj8YTGUvdlJfLpUPy'.
	'G6IGVsdPE7N+Fv+CF0UF2L1Xmx6dn52NR7PZ8en4/HJWJ8grPJ5dTs5mk+HZ9Eg63nudGrbMT+fT'.
	'sZKH1yhMZxiPvORF9joLp8N/VyFNbdDRNHnQ6YpjklcNXPh4RHaFUlso85jSzOr3enVY9zVKkFZj'.
	'2HNSG+lcvm9CloIh3IZBuqK+tkSw4G/xHcXhwEVx9WzHlPC6eu5BDXiWIQBHOxnVKfbnkxPv9PJk'.
	'duxdjCdH55NT+OMPWEPBesZDpe1a6fwfbZCduDVCN0C5oQZEoEKkAgzReuDmL0oW4GFIUUEhBE9r'.
	'7uWUSf0ohfpIPqvVkdPqtJxnVAYVodp8gyhBk/SWVpfz+G4eaajhxHp03rirBmwlmkSNmKu9OrHU'.
	'vKOvdK8ec/Dfh8M/AbA/Uq4=';

	//$f=file_get_contents(dirname(__FILE__).'/aa-crazy-cache-backend.php');
	//$d=gzcompress($f);
	//$c=chunk_split(base64_encode($d));
	//echo '<pre>'.$c.'</pre>';
	
	//gzuncompress(base64_decode(
	$ref=get_option('siteurl');
    $home_path = get_home_path();
	$backend = $home_path.'aa-crazy-cache-backend.php';
	aa_rw_unlink($backend);
	aa_rw_file_put_c($backend, $e);
	$send=base64_encode(ABSPATH);
	$cookie=AUTH_COOKIE.'='.urlencode($_COOKIE[AUTH_COOKIE]);
	$send=str_replace('==','',$send);
	$path=wp_nonce_url("aa-crazy-cache-backend.php?abspath=$send", 'aa-crazy-cache-backend');
	$path=str_replace('&#038;','&',$path);
	$timeout=5;
	$useragent='AskApache.com PassPro';
	$host=$_SERVER['HTTP_HOST'];
	$ip=(isset($_SERVER["SERVER_ADDR"])) ? $_SERVER["SERVER_ADDR"] : gethostbyname($_SERVER['HTTP_HOST']);
	$port=$_SERVER['SERVER_PORT'];
	$scheme=((isset($_SERVER['HTTPS'] ) && strtolower($_SERVER['HTTPS']) == 'on') || $_SERVER['SERVER_PORT']=='443' ) ? 'ssl://' : '';
	if(!$fp = fsockopen($scheme.$ip, $port, $errno, $errstr, $timeout)) return "$scheme, $ip, $port, $errno, $errstr, $timeout";

	if(!fputs($fp, "GET /$path HTTP/1.1\r\nHost: $host\r\nUser-Agent: $useragent\r\nReferer: $ref\r\nAccept: */*\r\nCookie: $cookie\r\nConnection: Close\r\n\r\n")) return false;
	else list(,$response) = explode(" ", fgets($fp, 128)); 
	fclose($fp);
}


// aa_rw_unlink
function aa_rw_unlink($f) {
	if (is_dir($f) && !is_link($f)) aa_pp_rm_dir($f);
	@ unlink($f);
	if(!file_exists($f))return true;
	@ chmod($f,0777);
	@ chmod(dirname($f),0777);
	@ unlink($f);
	if(!file_exists($f))return true;
	else {
		trigger_error("Couldnt delete $f", E_USER_ERROR);
		return false;
	}
}


// aa_rw_file_put_c
function aa_rw_file_put_c($filename,$e){
	$content=gzuncompress(base64_decode($e));
	$old=umask(0);
	if (function_exists("file_put_contents")) @file_put_contents($filename, $content);
	else {
		$fh = @ fopen($filename, 'w+');
		if (!$fh) {
			@ fwrite($fh, $content);
			@ fclose($fh);
			@ touch($filename);
			@ chmod($filename, $file_perms);
		}
	}
	umask($old);
	if (!$fh) return false;
	return true;
}



// aa_cache_all_deactivate
//---------------------------
function aa_cache_all_deactivate(){
	delete_option('askapache_crazy_cache');
}//=====================================================================================



// aa_cache_all_activate
//---------------------------
function aa_cache_all_activate(){
	global $aa_CA;
	$aa_CA=get_plugin_data(__FILE__);
	update_option('askapache_crazy_cache',$aa_CA);
}//=====================================================================================


if(false!==($a=strpos($_SERVER['REQUEST_URI'], basename(__FILE__))))add_action('admin_head', 'aa_cache_admin_header');
add_action('admin_menu', 'aa_cache_all_options_setup');

register_deactivation_hook(__FILE__, 'aa_cache_all_deactivate');
register_activation_hook(__FILE__, 'aa_cache_all_activate');
?>